/* Make4bit.cpp */
/* 14/04/98 Florent Dhordain */

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <alloc.h>

typedef unsigned char byte;
typedef unsigned short word;

#define LOBYTE(w)  ((byte)(w))
#define HIBYTE(w)  ((byte)(((word)(w) >> 8) & 0xFF))

#define WORDSUM(w) ((word) (LOBYTE(w)+HIBYTE(w)))

#define HDRLEN 0x35
char header83p[HDRLEN]
/* 01234567   8   9 ABCDEF0123456789ABCDEF0123456789ABCDEF012345*/
= "**TI83**\x1A\x0A\0WAV sound file generated by Make4bit v1.0.";


int infile, outfile;
char inname[255], outname[255];

char *buffer, *outbuf;

long bufsize;
long i;
word outsize, progsize, datapartsize, filedatasize;
word varheadersize=0x000b;

word checksum;

char progname[9]="\x06\0\0\0\0\0\0\0\0";
char wavhdr[5]="\0WAV\x04";

char desclen;
char desc[40];

#define WAVHEADERLEN 61

int main(int argc, char *argv[])
{
	if (argc!=2) {
		printf("Syntax - %s wavfile (without extension)\n", argv[0]);
		return 1;
	}

	strcat(strcpy(inname,argv[1]),".wav");
	strcat(strcpy(outname,argv[1]),".83p");

	printf("Make4Bit v1.0 by Florent Dhordain\n"
	       " Input file is %s\n Output file is %s\n", inname, outname);

	if ((infile=open(inname, O_RDONLY | O_BINARY, 0))==-1) {
		printf("Error while opening %s\n", inname);
		return 1;
	}

	if ((outfile=open(outname, O_WRONLY | O_CREAT | O_TRUNC | O_BINARY,
		  S_IREAD |S_IWRITE))==-1) {
		printf("Error while creating %s\n", outname);
		close(infile);
		return 1;
	}

	if ((bufsize=(filelength(infile)-61))<0) {
		printf("%s isn't a WAVE file\n", inname);
		close(infile);
		close(outfile);
		return 1;
	}

	bufsize++;
	if (!((buffer = (char *) malloc(bufsize))
		&& (outbuf = (char *) malloc(bufsize/2)))) {
		printf("Couldn't allocate buffers\n");
		close(infile);
		close(outfile);
		return 1;
	}

	lseek(infile, 61, SEEK_SET);
	_read(infile, buffer, filelength(infile)-61);
	close(infile);

	for(i=0;i<8;i++) if ((progname[1+i]=(argv[1])[i])==0) i=8;

	printf("Sound description:");
	gets(desc);
	if ((desclen=strlen(desc)+1)==1) desclen=0;	/* No desc if there's only a \0 */

	outsize = bufsize/2;
	progsize = outsize+0x7+desclen; /* +2 size, + 5 for WAVhdr, +comment */
	datapartsize = progsize+2;

	for (i=0;i<(outsize);i++)
		outbuf[i]=(buffer[2*i]>>4)&0x0F | (buffer[2*i+1]&0xF0);

	_write(outfile, &header83p, HDRLEN);
	filedatasize=progsize+0x11;
	_write(outfile, &filedatasize, 2);
	_write(outfile, &varheadersize, 2);
	_write(outfile, &datapartsize, 2);
	_write(outfile, &progname, 9);
	_write(outfile, &datapartsize, 2);
	_write(outfile, &progsize, 2);
	_write(outfile, &wavhdr, 5);
	_write(outfile, &outsize, 2);
	_write(outfile, outbuf, outsize);
	if (desclen!=0) _write(outfile, &desc, desclen);

	/* compute checksum : from byte 0x37 (after header) to end */
	checksum=0xB+3*WORDSUM(progsize)+4+6+WORDSUM(outsize)+'W'+'A'+'V'+4;
	for(i=1;i<9;i++) checksum+=(byte) progname[i];
	for(i=0;i<outsize;i++) checksum+=(byte) outbuf[i];
	if (desclen!=0) for (i=0;i<desclen;i++) checksum+= (byte) desc[i];

	_write(outfile, &checksum,2);
	close(outfile);

	printf("Done !\n");

	return 0;
}







